function GenMGraphMatlab

clc

%Probname = {'1dc.64'; '1dc.128'; '1dc.256'; '1dc.512'; '1dc.1024'; '1dc.2048'; '1et.64'; '1et.128'; '1et.256'; '1et.512'; '1et.1024'; '1et.2048'; '1tc.64'; '1tc.128'; '1tc.256'; '1tc.512'; '1tc.1024'; '1tc.2048'; '1zc.128'; '1zc.256'; '1zc.512'; '1zc.1024'; '1zc.2048'; '1zc.4096'; '2dc.128'; '2dc.256'; '2dc.512'; '2dc.1024'; '2dc.2048'};

Probname = {'1dc.64'; '1et.64'; '1tc.64';
    '1dc.128'; '1et.128'; '1tc.128'; '1zc.128'; '2dc.128';
    '1dc.256'; '1et.256';  '1tc.256'; '1zc.256'; '2dc.256'; 
    '1dc.512'; '1et.512'; '1tc.512';  '1zc.512'; '2dc.512'; 
    '1dc.1024'; '1et.1024';  '1tc.1024';  '1zc.1024'; '2dc.1024';
    '1dc.2048'; '1et.2048';    '1tc.2048';  '1zc.2048';  '2dc.2048'
    '1zc.4096';  };

nprob = length(Probname);

Problist = [1:nprob];

% Problist = [7];

for di = 1:length(Problist)
    
    name = Probname{Problist(di)};

    file = strcat(name,'.txt');
    fid = fopen(file, 'r');
    fscanf(fid, '%s %s', 2);
    n = fscanf(fid, '%d', 1);
    p = fscanf(fid, '%d', 1);
    E = fscanf(fid, '%s %d %d', [3, p]);    % It has two rows now.

    E = E(2:3,:); E = E';
    fclose(fid);
    
    d = true(p,1);
    T = logical(sparse(E(:,1), E(:,2), d, n, n));

    fprintf('Prob: %s, Trace(T): %f\n', name, full(sum(diag(T))));

    % Be careful, only take the upper triangle matrix of T
    TL = tril(T);
    if sum(sum(TL)) > 0
        T = triu(T);
        [row,col] = find(T);
        p = length(row);     E = zeros(p,2);
        E(:,1) = row; E(:,2) = col;
    end
        
    m = p + 1;
    
    
    
% 
% 
%     C = sparse(A(:,1), A(:,2), A(:,3), n, n);
%     C = (C'+C);
% 
%     %     spy(C)
%     e = ones(n,1);
%     C = -(spdiags(C*e,0,n,n)-C)/4;
% 
    file = strcat(name,'_Alt.mat');
    save(file, 'n', 'm', 'p','T','E');

end

