function GenTheta_mat

clc


Probname ={'MANN-a27', 'johnson8-4-4', 'johnson16-2-4', 'san200-0.7-1', 'sanr200-0.7', 'c-fat200-1', ...
        'hamming-10-2', 'hamming-11-2', 'hamming-6-4', 'hamming-7-5-6', 'hamming-8-3-4', 'hamming-8-4', ...
        'hamming-9-5-6', 'hamming-9-8', 'brock200-1', 'brock200-4', 'brock400-1', ...
        'G43', 'G44', 'G45', 'G46', 'G47', 'G51', 'G52', 'G53', 'G54', 'keller4', 'p-hat300-1'};
    
nprob = length(Probname);

Problist = [1:nprob];

% Problist = [1];

for di = 1:length(Problist)
    
    name = Probname{Problist(di)};

    load(strcat(name,'.mat'), 'At', 'K');
    n  = K.s;
    m = size(At,2);  p = m - 1;

    if norm(reshape(At(:,1),n,n) - speye(n), 'fro') > 0
        error('The first column of At is not an identity matrix');
    end
     

    T = logical(reshape(At(:,2:end)*ones(p,1), n,n));
    
    fprintf('Prob: %s, Trace(T): %f\n', name, full(sum(diag(T))));

    % Be careful, only take the upper triangle matrix of T
    TL = tril(T);
    if sum(sum(TL)) > 0
        T = triu(T);
        [row,col] = find(T);
        p = length(row);     E = zeros(p,2);
        E(:,1) = row; E(:,2) = col;
    end
        

    file = strcat(name,'_Alt.mat');
    save(file, 'n', 'm', 'p','T','E');

end

