function TestThetaG_HammingProbTable_theta_rho1

clc
close all;
clear all


src = '/home/wenzw/code/ConvexOpt/SDP/AltSDPData/';

 Probname ={'theta4', 'theta42',  'theta6',  'theta62',   'theta8',   'theta82',  'theta83', 'theta10', 'theta102',...  %1- 9
        'theta103', 'theta104',  'theta12',   'theta123','theta32', ...     %10-14
        'MANN-a27', 'johnson8-4-4', 'johnson16-2-4', 'san200-0.7-1', 'sanr200-0.7', 'c-fat200-1', ...  %15-20
         'hamming-6-4', 'hamming-7-5-6', 'hamming-8-3-4', 'hamming-8-4', ...  %21-24
        'hamming-9-5-6', 'hamming-9-8', 'hamming-10-2', 'brock200-1', 'brock200-4', 'brock400-1', ...  %25-30
         'keller4', 'p-hat300-1', 'G43', 'G44', 'G45', 'G46', 'G47', 'G51', 'G52', 'G53', 'G54', ...  %31-41
    '1dc.64', '1et.64', '1tc.64',  ...                  % 1-3
    '1dc.128', '1et.128', '1tc.128', '1zc.128', '2dc.128',  ... % 4-8
    '1dc.256', '1et.256',  '1tc.256', '1zc.256', '2dc.256', ...  % 9-13
    '1dc.512', '1et.512', '1tc.512',  '1zc.512', '2dc.512', ...  % 14-18
    '1dc.1024', '1et.1024',  '1tc.1024',  '1zc.1024', '2dc.1024', ... %19-23
    '1dc.2048', '1et.2048',    '1tc.2048',  '1zc.2048',  '2dc.2048'}; %24-28


nprobHamm = 41;
nprob = length(Probname);

Problist = [1:nprob];
Problist = [1];
% % Problist = [1:14];
% % Problist = [1:18];
% % Problist = [1:13]+nprobHamm;
% Problist = [1:13]+nprobHamm;
% Problist = [21];
% 

Problist = [[9 10 11 13 15 19  20  23 25 27 30  31 32 33 34 35 36 37  ]  [ 18:28]+41] ;
%Problist = [ 9 10 11 13 15 19];
Problist = [9 10 11 13 15 19  20  23 25 30  31 32   18+41] ;
%% % Problist = [[33 34 35 36 37  ]  [ 14:28]+41] ;
Problist = [9  ] ;
% Problist = [14  ] +41;
% % Problist =  [ 25:28]+41 ;

% problem 9 not good for plus
fprintf('name & n  & m & pobj & dobj & pinf & dinf & itr &  gap & cpu \n');

outBIQ = zeros(nprob, 9);

fname = '_mm_';


for di = 1:length(Problist)
    name = Probname{Problist(di)};
    load(strcat(src, name, '_Alt.mat'), 'm','n','p','T','E');


    % %%-----------------------------------------------------------------------
    % % SDP - First-order Primal dual alternating direction algorithm
    %
    opts.mxitr = 1000;

    opts.record = 0;

    opts.mu = 5;
    opts.rmu = 0.5;
    opts.mu_min = 1e-4;         opts.mu_max = 1e4;
    opts.min_mu_itr= 5;
    opts.max_mu_itr= 100;

    opts.max_itr_stag_lev1 = 20;
    opts.max_itr_stag_lev2 = 50;
    opts.max_itr_stag_lev3 = 150;

    opts.rho = 1;
    opts.delta_mu_l = 1;
    opts.delta_mu_u = 1;
    
    tol = 1e-6; opts.ftol = tol;
    
    opts.subopt = true;
    opts.subopt = false;

    % methods of projection
    opts.proj = 1; opts.nev = floor(sqrt(2*m));

    X0 = eye(n); %X0 = zeros(n);

    tic; [X, S, y, out] = mexAltSDP_Theta(n, m, X0, E, opts); solvet = toc;   objf = out.pobj;
 

   fprintf('%10s & %10d & %10d & %8.7e & %8.7e & %3.2e & %3.2e &  %10d & %3.2e  & %8.2f \\\\ \\hline \n', ...
       name, n, m, out.pobj, out.dobj, out.pinf, out.dinf, out.itr, out.gap, solvet);
   fid = fopen(strcat('result/',Probname{Problist(di)}, fname, num2str(opts.rho), '_theta_result.txt'), 'w');
   fprintf(fid,'%10s & %10d & %10d & %8.7e & %8.7e & %3.2e & %3.2e &  %10d & %3.2e  & %8.2f \\\\ \\hline \n', ...
       name, n, m, out.pobj, out.dobj, out.pinf, out.dinf, out.itr, out.gap, solvet);   
   
   
   fclose(fid);    

    %     objfs = Probinf{Problist(di), 2};
    %     fprintf('obj: %e, RRSDP-obj: %e, rel.err: %3.2e\n', ...
    %             objfs, objf,abs(objfs-objf)/(1+abs(objfs)));

   outBIQ(di, 1) = Problist(di);
   outBIQ(di, 2) = n;
   outBIQ(di, 3) = out.pobj;
   outBIQ(di, 4) = out.dobj;
   outBIQ(di, 5) = out.pinf;
   outBIQ(di, 6) = out.dinf;
   outBIQ(di, 7) = out.gap;
   outBIQ(di, 8) = out.itr;
   outBIQ(di, 9) = solvet;
   
%    save resultTheta1  outBIQ  Probname  

   save resultTheta  outBIQ  Probname  

end


% fprintf('performance: \n');
% fprintf('%3.2e   %8.2f\n',  [outBIQ(:, 7) outBIQ(:, 9)]');
